package main

import (
	"fmt"
	"time"
)

const (
	NoLog = iota
	Error
	Warn
	Info
	Debug
	Trace
)

type Logger struct {
	name  string
	level int
}

func (l *Logger) log(level int, msg string) {
	now := time.Now()
	if level <= l.level {
		fmt.Println(now.Format("2006-01-02 15:04:05"), " ", l.name, ": ", msg)
	}
}

func (l *Logger) Error(msg string) {
	l.log(Error, msg)
}

func (l *Logger) Warn(msg string) {
	l.log(Warn, msg)
}

func (l *Logger) Info(msg string) {
	l.log(Info, msg)
}

func (l *Logger) Debug(msg string) {
	l.log(Debug, msg)
}

func (l *Logger) Trace(msg string) {
	l.log(Trace, msg)
}
func GetLogger(name string) Logger {
	return Logger{name, 0}
}
